import struct
import numpy as np

def writeGrafic(filename, field, BoxSize, scalefac, **cosmo):

    with file(filename, mode="wb") as f:
        checkPoint = 4*11
        
        Nx,Ny,Nz = field.shape
        delta = BoxSize/Nx/cosmo['h']
        bad = 0.0
        
        f.write(struct.pack("IIIIffffffffI", checkPoint, 
                                          Nx, Ny, Nz, 
                                          delta, 
                                          bad, bad, bad, 
                                          scalefac,
                                          cosmo['omega_M_0'], cosmo['omega_lambda_0'], 100*cosmo['h'], checkPoint))
        checkPoint = 4*Ny*Nz
        for i in xrange(Nx):
            f.write(struct.pack("I", checkPoint))
            f.write(field[i].astype(np.float32).tostring())
            f.write(struct.pack("I", checkPoint))
        
